diff a/test/hotspot/jtreg/gc/shenandoah/jvmti/TestHeapDump.java b/test/hotspot/jtreg/gc/shenandoah/jvmti/TestHeapDump.java
--- a/test/hotspot/jtreg/gc/shenandoah/jvmti/TestHeapDump.java
+++ b/test/hotspot/jtreg/gc/shenandoah/jvmti/TestHeapDump.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2017, 2020, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -61,10 +62,50 @@
  *      -XX:+UseShenandoahGC -Xmx128m
  *      -XX:ShenandoahGCHeuristics=aggressive
  *      -XX:+UseStringDeduplication TestHeapDump
  */
 
+/**
+ * @test id=generational
+ * @summary Tests JVMTI heap dumps
+ * @requires vm.gc.Shenandoah
+ * @requires vm.jvmti
+ * @compile TestHeapDump.java
+ * @run main/othervm/native/timeout=300 -agentlib:TestHeapDump
+ *      -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC -Xmx128m
+ *      -XX:ShenandoahGCMode=generational
+ *      TestHeapDump
+ *
+ */
+
+/**
+ * @test id=no-coops-generational
+ * @summary Tests JVMTI heap dumps
+ * @requires vm.gc.Shenandoah
+ * @requires vm.jvmti
+ * @requires vm.bits == "64"
+ * @compile TestHeapDump.java
+ * @run main/othervm/native/timeout=300 -agentlib:TestHeapDump
+ *      -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC -Xmx128m
+ *      -XX:ShenandoahGCMode=generational
+ *      -XX:-UseCompressedOops TestHeapDump
+ */
+
+/**
+ * @test id=generational-strdedup
+ * @summary Tests JVMTI heap dumps
+ * @requires vm.gc.Shenandoah
+ * @requires vm.jvmti
+ * @compile TestHeapDump.java
+ * @run main/othervm/native/timeout=300 -agentlib:TestHeapDump
+ *      -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC -Xmx128m
+ *      -XX:ShenandoahGCMode=generational
+ *      -XX:+UseStringDeduplication TestHeapDump
+ */
 import java.lang.ref.Reference;
 
 public class TestHeapDump {
 
     private static final int NUM_ITER = 10000;
